Index: trunk/kernel/syscalls/sys_stat.c
===================================================================
--- trunk/kernel/syscalls/sys_stat.c	(revision 1)
+++ trunk/kernel/syscalls/sys_stat.c	(revision 23)
@@ -1,15 +1,16 @@
 /*
- * kern/sys_stat.c - stats a file or directory
+ * sys_stat.c - Return statistics on a file or directory.
  * 
- * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
- * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ * Author    Alain Greiner  (2016,2017)
  *
- * This file is part of ALMOS-kernel.
+ * Copyright (c) UPMC Sorbonne Universites
  *
- * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -17,64 +18,70 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
+#include <hal_types.h>
+#include <hal_uspace.h>
+#include <hal_special.h>
 #include <errno.h>
 #include <thread.h>
+#include <printk.h>
 #include <vfs.h>
-#include <sys-vfs.h>
-#include <task.h>
-#include <spinlock.h>
-#include <cpu-trace.h>
+#include <vmm.h>
+#include <process.h>
 
+//////////////////////////////////////////
+int sys_stat( uint32_t            file_id,
+              struct vfs_stat_s * stat )
+{
+    error_t           error;
+    paddr_t           paddr;
+    struct vfs_stat_s k_stat;
+    xptr_t            file_xp;
+	
+	thread_t  * this    = CURRENT_THREAD;
+	process_t * process = this->process;
 
-int sys_stat(char *pathname, struct vfs_stat_s *buff, int fd)
-{
-	CPU_HW_TRACE(sys_stat);
-	struct thread_s *this;
-	register error_t err = 0;
-	struct vfs_file_s *file;
-	struct ku_obj ku_path;
-	struct task_s *task;
+    // check stat structure in user space
+    error = vmm_v2p_translate( false , stat , &paddr );
 
-	file = NULL;
-	this = current_thread;
-	task = current_task;
+	if( error )
+	{
+        printk("\n[ERROR] in %s : stat structure unmapped  for thread %x in process %x\n",
+               __FUNCTION__ , this->trdid , process->pid );
+		this->errno = EINVAL;
+		return -1;
+	}	
 
-	if((buff == NULL) || ((pathname == NULL) && (fd == -1)))
+    // get extended pointer on remote file descriptor
+    file_xp = process_fd_get_xptr( process , file_id );
+
+    if( file_xp == XPTR_NULL )
+    {
+        printk("\n[ERROR] in %s : undefined file descriptor for thread %x in process %x\n",
+               __FUNCTION__ , this->trdid , process->pid );
+        this->errno = EBADFD;
+        return -1;
+    }
+
+    // call the relevant VFS function
+    error = vfs_stat( file_xp,
+                      &k_stat );
+    if( error )
 	{
-		this->info.errno = EINVAL;
-		CPU_HW_TRACE(sys_stat);
+        printk("\n[ERROR] in %s : cannot access file %d for thread %x in process %x\n",
+               __FUNCTION__ , file_id , this->trdid , process->pid );
+		this->errno = error;
 		return -1;
 	}
+   
+    // copy stat to user space
+    hal_copy_to_uspace( stat , &k_stat , sizeof(struct vfs_stat_s) );
 
-	if(NOT_IN_USPACE((uint_t)buff))
-	{
-		this->info.errno = EPERM;
-		CPU_HW_TRACE(sys_stat);
-		return -1;
-	}
+    hal_wbflush();
 
-	if(pathname == NULL)
-	{
-		if((fd >= CONFIG_TASK_FILE_MAX_NR) || (task_fd_lookup(task, fd, &file)))
-		{
-			CPU_HW_TRACE(sys_stat);
-			return EBADFD;
-		}
- 
-		err = vfs_stat(&task->vfs_cwd, NULL, buff, file);
-	}
-	else
-	{
-		KU_BUFF(ku_path, pathname);
-		rwlock_rdlock(&task->cwd_lock);
-		err = vfs_stat(&task->vfs_cwd, &ku_path, buff, NULL);
-		rwlock_unlock(&task->cwd_lock);
-	}
- 
-	this->info.errno = err;
-	CPU_HW_TRACE(sys_stat);
 	return 0;
-}
+
+}  // end sys_stat()
+
